unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, system.Types, Vcl.ExtDlgs, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Button2: TButton;
    Button3: TButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    Image1: TImage;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    LabeledEdit7: TLabeledEdit;
    LabeledEdit8: TLabeledEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    procedure FileOpen(InF : Boolean);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.UITypes, system.UIConsts, Vcl.Imaging.GIFImg;

var
  BaseBM, DrawBM, NewPic: TBitmap;
  InF  : boolean;
  inpf : byte;

const
// t@Cgqݒ
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

//----------------------------------------------------------------
// difference_Bitmap 2̃rbg}bv̍ɂ摜o
// BaseBM     wĩrbg}bv
// uperBM @@BaseBM̏̑Oirbg}bv
// X, Y   @@uperBM`悷BaseBM̍W
// R, G, B  @ԁA΁A@臒l
// H, S, L    FAʓxAPx
// HF         false FMRGB  true F H S L
//----------------------------------------------------------------
function difference_Bitmap(BackBM, UperBM: TBitmap; X, Y: integer; R, G, B: smallint;
                                                  H, S, L: single; HF: Boolean): TBitmap;
type
  TAlphaarry = array[0..0] of TAlphaColor;    // TAlphaColorz Sbyte
  PAlphaarray = ^TAlphaarry;                  // z̃|C^[

var
  PBase, PDraw: PRGBQuadArray;        // XLC̃LbVp|C^
  Hbase, HDraw: PAlphaarray;          // XLC̃LbVp|C^
  CutBase, CutDraw: TBitmap;          // ҏWprbg}bv
  Row, Col : integer;                 // zXLp
  Rb, Gb, Bb: Smallint;
  Ru, Gu, Bu: Smallint;
  Ri, Gi, Bi: Smallint;
  Rect1, Rect2: TRect;                // lp̈
  Xi, Yi: integer;                    // Oi摜͈͐擪ʒuvZp
  BColor, UColor : TAlphaColor;
  Hb, Sb, Lb : single;
  Hu, Su, Lu : single;
  Hi, Si, Li : single;
  Pcount     : integer;               // osNZ̐
begin
  Result := BackBM;               // ߂lwi摜
  // wi摜̎lp`̈
  Rect1 := Rect(0, 0, BackBM.Width, BackBM.Height);
  // Oi摜̗̈ 摜͈͊O
  Rect2 := Rect(X, Y, UperBM.Width + X, UperBM.Height + Y);
  // wi摜̉摜̏dȂ͈͌vZ Rect1
  if not IntersectRect(Rect1, Rect1, Rect2) then begin
    ShowMessage('̉摜dȂ镔܂');
    Exit;
  end;
  // NewPic0BackBMrbg}bvC[WRs[
  NewPic.Assign(BackBM);
  // Oi摜̏dȂ͈͌vZ Rect2
  Xi := -X;                     // ͈͊O]
  if X >= 0 then Xi := 0;       // XvX̏ꍇ0
  Yi := -Y;                     // ͈͊O]
  if Y >= 0 then Yi := 0;       // YvX̏ꍇ㑤0
  Rect2 := Rect(Xi, Yi, Rect1.Right - X, Rect1.Bottom - Y);

  // ҏWprbg}bv
  CutBase := TBitmap.Create;
  CutDraw := TBitmap.Create;
  // 摜̍
  try
    CutBase.Width       := Rect1.Right  - Rect1.Left;     // 摜̏dȂ镔̔wi摜
    CutBase.Height      := Rect1.Bottom - Rect1.top;      // 摜̏dȂ镔̔wi摜
    CutBase.PixelFormat := pf32bit;
    CutDraw.Width       := Rect1.Right  - Rect1.Left;     // 摜̏dȂ镔̑Oi摜
    CutDraw.Height      := Rect1.Bottom - Rect1.top;      // 摜̏dȂ镔̑Oi摜
    CutDraw.PixelFormat := pf32bit;

    // wi摜dȂ镔̉摜Rs[
    CutBase.Canvas.CopyRect(Rect(0, 0, CutBase.Width, CutBase.Height), Newpic.Canvas, Rect1);
    // Oi摜dȂ镔̉Rs[
    CutDraw.Canvas.CopyRect(Rect(0, 0, CutDraw.Width, CutDraw.Height), UperBM.Canvas, Rect2);
    // dȂ镔̍ɂRs[
    // RGBɂݒ
    Pcount := 0;
    if not HF then begin
      for Col := 0 to CutBase.Height -1 do begin
        PBase := CutBase.ScanLine[Col];
        PDraw := CutDraw.ScanLine[Col];
        for Row := 0 to CutBase.Width -1 do begin
          // eF̒lo
          Rb := PBase[Row].rgbRed;
          Gb := PBase[Row].rgbGreen;
          Bb := PBase[Row].rgbBlue;

          Ru := PDraw[Row].rgbRed;
          Gu := PDraw[Row].rgbGreen;
          Bu := PDraw[Row].rgbBlue;
          // vZ
          Ri := ABS(Rb - Ru);
          Gi := ABS(Gb - Gu);
          Bi := ABS(Bb - Bu);
          // ɂF̐ݒ wl荷傫eF̃Rs[
          if (Ri > R) or (Gi > G) or (Bi > b) then begin
            PBase[Row].rgbRed   := PDraw[Row].rgbRed;
            PBase[Row].rgbGreen := PDraw[Row].rgbGreen;
            PBase[Row].rgbBlue  := PDraw[Row].rgbBlue;
            inc(Pcount);
          end
          // wl菬甒ɐݒ
          else
          begin
            PBase[Row].rgbRed   := 255;
            PBase[Row].rgbGreen := 255;
            PBase[Row].rgbBlue  := 255;
          end;
          PBase[Row].rgbReserved := 0;
        end;
      end;
    end
    // HSLɂݒ
    else begin
      for Col := 0 to CutBase.Height -1 do begin
        HBase := CutBase.ScanLine[Col];
        HDraw := CutDraw.ScanLine[Col];
        for Row := 0 to CutBase.Width -1 do begin
          // F̒lSbyteo
          BColor := HBase[Row];
          UColor := HDraw[Row];
          // HSLϊ
          RGBtoHSL(BColor, Hb, Sb, Lb);
          RGBtoHSL(UColor, Hu, Su, Lu);
          // vZ
          hi := abs(hb - hu);               // F̍
          if hi > 0.5 then hi := 1 - Hi;    // F̍ől0.5 F 0`1 Of[^[ł
          Si := abs(Sb - Su);               // ʓx̍
          Li := abs(Lb - Lu);               // Px̍
          // ɂFݒ
          if (Hi > H) or (Si > S) or (Li > L) then begin
            HBase[Row] := HDraw[Row] and $00FFFFFF;
            inc(Pcount);
          end
          else
          begin
                         //  R G B
            HBase[Row] := $00FFFFFF;        // sɐݒ
          end;
        end;
      end;
    end;
    // dȂ镔̉摜𗠉摜ɃRs[
    NewPic.Canvas.CopyRect(Rect1, CutBase.Canvas, rect(0, 0, CutBase.Width, CutBase.Height));
    Result := NewPic;    // ߂l摜
    Form1.label1.Caption := 'o' + intTostr(Pcount);
  finally
    // ҏWprbg}bv̉
    CutBase.Free;
    CutDraw.Free;
  end;
end;

procedure TForm1.FileOpen(InF : Boolean);
var
  WIC         : TWICImage;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;        // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                  // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                        // TWICImage̐
      try
        WIC.LoadFromFile(OpenPictureDialog1.FileName);// 摜̓ǂݍ
        // Oi摜ǂݍ
        if InF then begin
          DrawBM.Width   := WIC.Width;                // 摜
          DrawBM.Height  := WIC.Height;               // 摜
          DrawBM.Canvas.Draw(0, 0, WIC);              // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
          inpf := inpf or 1;                          // Oi摜ǂݍݍςݐݒ
        end
        // wi摜ǂݍ
        else Begin
          BaseBM.Width  := WIC.Width;                 // 摜
          BaseBM.Height := WIC.Height;                // 摜
          BaseBM.Canvas.Draw(0, 0, WIC);              // DrawInBitmapɓ͉摜ݒtH[}bg24rbgɕϊ܂
          image1.Width  := WIC.Width;                 // `Imagegݒ
          image1.Height := WIC.Height;                // wi摜ǂݍݍςݐݒ
          inpf := inpf or 2;
        end;
      finally
        WIC.Free;                                     // TWICImage 
      end;
    end;
  if inpf and 3 = 3 then Button1.Enabled := true;     // wi摜ƑOi摜ǂݍ܂ꂽ獇{^Cl[u
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  X, Y, Ch: integer;
  R, G, B:  smallint;
  H, S, L:  single;
  HF     : boolean;
begin
  val(LabeledEdit1.Text, X, Ch);
  if ch <> 0 then begin
    application.MessageBox('ʒu̒lɊԈႢ܂B','̓~X', 0);
    exit;
  end;
  val(LabeledEdit2.Text, Y, Ch);
  if ch <> 0 then begin
    application.MessageBox('cʒu̒lɊԈႢ܂B','̓~X', 0);
    exit;
  end;
  HF := False;
  R := 0;
  G := 0;
  B := 0;
  H := 0;
  S := 0;
  L := 0;
  if RadioButton1.Checked then begin
    val(LabeledEdit3.Text, R, Ch);
    if ch <> 0 then begin
      application.MessageBox('ԍlɊԈႢ܂B','̓~X', 0);
      exit;
    end;
    if (R < 0) or (R > 255) then begin
      application.MessageBox('ԍl͈͊OłB','̓~X', 0);
      exit;
    end;
    val(LabeledEdit4.Text, G, Ch);
    if ch <> 0 then begin
      application.MessageBox('΍lɊԈႢ܂B','̓~X', 0);
      exit;
    end;
    if (G < 0) or (G > 255) then begin
      application.MessageBox('΍l͈͊OłB','̓~X', 0);
      exit;
    end;
    val(LabeledEdit5.Text, B, Ch);
    if ch <> 0 then begin
      application.MessageBox('lɊԈႢ܂B','̓~X', 0);
      exit;
    end;
    if (B < 0) or (B > 255) then begin
      application.MessageBox('l͈͊OłB','̓~X', 0);
      exit;
    end;
  end;
  if RadioButton2.Checked then begin
    val(LabeledEdit6.Text, H, Ch);
    if ch <> 0 then begin
      application.MessageBox('FlɊԈႢ܂B','̓~X', 0);
      exit;
    end;
    if (H < 0) or (H > 360) then begin
      application.MessageBox('F͈͊OłB','̓~X', 0);
      exit;
    end;
    H := H / 360;
    val(LabeledEdit7.Text, S, Ch);
    if ch <> 0 then begin
      application.MessageBox('ʓxlɊԈႢ܂B','̓~X', 0);
      exit;
    end;
    if (S < 0) or (S > 1) then begin
      application.MessageBox('ʓxl͈͊OłB','̓~X', 0);
      exit;
    end;
    val(LabeledEdit8.Text, L, Ch);
    if ch <> 0 then begin
      application.MessageBox('PxlɊԈႢ܂B','̓~X', 0);
      exit;
    end;
    if (L < 0) or (L > 1) then begin
      application.MessageBox('Pxl͈͊OłB','̓~X', 0);
      exit;
    end;
    HF := True;
  end;

  // 摜̍
  Image1.Canvas.Draw(0, 0, difference_Bitmap(BaseBM, DrawBM, X, Y, R, G, B, H, S, L, HF));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  InF := False;       // wi摜ǂݍ݃tO
  FileOpen(InF);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  InF := True;;       // Oi摜ǂݍ݃vO
  FileOpen(InF);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  // rbg}bv̉
  BaseBM.Free;
  DrawBM.Free;
  NewPic.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  // rbg}bv̐
  NewPic := TBitmap.Create;
  BaseBM :=TBitmap.Create;
  DrawBM :=TBitmap.Create;
  BaseBM.PixelFormat := pf32bit;
  DrawBM.PixelFormat := pf32bit;
  // 摜ǂݍ݃tONA O[oϐȂ̂ŖĂ
  inpf := 0;
end;

end.
